(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱C|Option|j| *)

unit MOption;

interface

uses PullMenu,Variable,PRMIn,PRMOut,DGINI,Dialog,Display,IOProc,DosCall;

Type Real=Double;

function  OptionBody(Sel:Integer):Boolean;

implementation

const

DataMenu :array [0..4] of String[17] =
   ('X-transformation ',
    'Y-transformation ',
    'Default transform',
    'Fit definition   ',
    'User defined func');
DefaultMenu:array [0..1] of String[2+20]=
   ('X:',
    'Y:');
WriteParamMenu:array [0..4] of String[15+5]=
   ('Full path     : ',
    'With data     : ',
    'Save environment',
    'Save as         ',
    'Save parameters ');
UserfuncMenu:array [0..1] of String[7+20]=
   ('f(x,y):',
    'g(x,y):');
LSQParamMenu:array [0..16] of String[13+20]=
   ('f(x;%00~%06):',
    'df(x)/d(%00):',
    'df(x)/d(%01):',
    'df(x)/d(%02):',
    'df(x)/d(%03):',
    'df(x)/d(%04):',
    'df(x)/d(%05):',
    'df(x)/d(%06):',
    '%00  l :',
    '%01  l :',
    '%02  l :',
    '%03  l :',
    '%04  l :',
    '%05  l :',
    '%06  l :',
    'w  :',
    'e덷():');


function OptionBody(Sel:Integer):Boolean;
var Remark2 : array[1..22] of String[30];
    Path,Fil:PathStr;
    Sel2,Sel3,Sel4,Sel5,i,j:Integer;
    Str0:String;
    WInput,Action:Boolean;
Const
      PathR:PathStr='*.PRM';
      TransTitle='CRI SHIFT+CRIE';
begin
    if Sel=1 then SelectMode(True,True,False,True)
             else SelectMode(True,False,False,True);
    OptionBody:=False;
    PullColor:=Color2.Menu2;
    case Sel of
    0: begin
       end;
    1: begin
         SelectMenuSFirst(PWinX,PWinY+2,1,5,17,0,5);
         SelectMode(True,False,False,True);
         repeat
             Sel2:=SelectMenuSNext(DataMenu,'','');
             case Sel2 of
                 0:begin
                     PullColor:=Color2.Setting;
                     SelectMenuSFirst(PWinX,PWinY+1,1,maxfil+1,30,0,maxfil+1);
                     repeat
                         for i:=1 to 20 do begin
                                 Str(i:2,Remark2[i]);
                                 Remark2[i]:=Remark2[i]+':'+FilePar.Body[i].ModX;
                         end;
                         Remark2[21]:='ALL MATH FORMULA';
                         Sel3:=SelectMenuSNextS(Remark2,'X-Transformation',TransTitle,maxfil);
                         if Sel3>=0 then begin
                             if Sel3=maxfil then begin
                                 for i:=1 to maxfil do SelMenu(i-1,30,Remark2);
                                 Sel3:=0;
                             end;
                             PullColor:=Color2.WindowInput;
                             if WindowInput(PWinX,PWinY+Sel3+1,40,FilePar.Body[Sel3+1].Modx,'EXPRESSION','') then
                                 for i:=1 to 20 do if Menued(i-1,30,Remark2) then
                                     FilePar.Body[i].Modx:=FilePar.Body[Sel3+1].Modx;
                         end;
                       until Sel3<0;
                       SelectMenuSEnd;
                     end;

                 1:begin
                     PullColor:=Color2.Setting;
                     SelectMenuSFirst(PWinX,PWinY+2,1,maxfil+1,30,0,maxfil+1);
                     repeat
                         for i:=1 to 20 do begin
                                 Str(i:2,Remark2[i]);
                                 Remark2[i]:=Remark2[i]+':'+FilePar.Body[i].Mody;
                         end;
                         Remark2[21]:='ALL MATH FORMULA';
                         Sel3:=SelectMenuSNextS(Remark2,'Y-Transformation',TransTitle,maxfil);
                         if Sel3>=0 then begin
                             if Sel3=maxfil then begin
                                 for i:=1 to maxfil do SelMenu(i-1,30,Remark2);
                                 Sel3:=0;
                             end;
                             PullColor:=Color2.WindowInput;
                             if WindowInput(PWinX,PWinY+Sel3+1,40,FilePar.Body[Sel3+1].Mody,'EXPRESSION','') then
                                 for i:=1 to 20 do if Menued(i-1,30,Remark2) then
                                     FilePar.Body[i].Mody:=FilePar.Body[Sel3+1].Mody;
                         end;
                     until Sel3<0;
                     SelectMenuSEnd;
                   end;
                 2:begin
                     PullColor:=Color2.Setting;
                     SelectMenuSFirst(PWinX,PWinY+3,1,2,2+20,0,2);
                     repeat
                       SetMenuVal(0,2+20,DefaultMenu,FilePar.Body[0].ModX,6,20);
                       SetMenuVal(1,2+20,DefaultMenu,FilePar.Body[0].ModY,6,20);
                       Sel3:=SelectMenuSNext(DefaultMenu,'','');
                       PullColor:=Color2.WindowInput;
                       case Sel3 of
                         0: Winput:=WindowInput(PWinX,PWinY+1,40,FilePar.Body[0].ModX,'EXPRESSOIN','');
                         1: Winput:=WindowInput(PWinX,PWinY+2,40,FilePar.Body[0].ModY,'EXPRESSOIN','');
                       end;
                     until Sel3<0;
                     SelectMenuSEnd;
                   end;
                 3:begin
                     PullColor:=Color2.Setting;
                     SelectMenuSFirst(PWinX,PWinY+4,1,17,13+20,0,17);
                     repeat
                       for i:=0 to 7 do SetMenuVal(i,13+20,LSQParamMenu,LSQPar.FitExp[i],6,20);
                       for i:=1 to 7 do SetMenuVal(i+7,13+20,LSQParamMenu,LSQPar.FitVal[i],4,0);
                       SetMenuVal(15,13+20,LSQParamMenu,LSQPar.FitDif,5,0);
                       SetMenuVal(16,13+20,LSQParamMenu,LSQPar.FitError,4,0);
                       Sel3:=SelectMenuSNext(LSQParamMenu,'Fit definition','');
                       case Sel3 of
                         0..7:
                            begin
                              PullColor:=Color2.WindowInput;
                              Winput:=WindowInput(PWinX+14,PWinY+Sel3+1,40,LSQPar.FitExp[Sel3],'EXPRESSION','');
                            end;
                         8..14:
                              Winput:=WindowInputReal(PWinX+14,PWinY+Sel3+1,'NEW VALUE',LSQPar.FitVal[Sel3-7],4);
                         15:toggle(LSQPar.FitDif);
                         16:if WindowInputReal(PWinX+14,PWinY+Sel3+1,'NEW VALUE(%)',LSQPar.FitError,4) then
                                LSQPar.FitError:=Abs(LSQPar.FitError);
                       end;
                     until (Sel3<0);
                     SelectMenuSEnd;
                   end;
                 4:begin
                     PullColor:=Color2.Setting;
                     SelectMenuSFirst(PWinX,PWinY+5,1,2,7+20,0,2);
                     repeat
                       for i:=0 to 1 do SetMenuVal(i,7+20,UserfuncMenu,NGRAPH.UserFn[i],6,20);
                       Sel3:=SelectMenuSNext(UserfuncMenu,'','');
                       if Sel3>=0 then begin
                           PullColor:=Color2.WindowInput;
                           Winput:=WindowInput(PWinX+8,PWinY+Sel3+1,40,NGRAPH.UserFn[Sel3],'EXPRESSOIN','');
                       end;
                     until Sel3<0;
                     SelectMenuSEnd;
                   end;
             end;
         until (Sel2<0);
         SelectMenuSEnd;
       end;

    2: if GetFileName(PWinX,PWinY+3,Fil,PathR,'.PRM','PARAMETER FILE') then begin
         if InputYN(PWinX,PWinY+3,'Really? (Y/N)') in ['Y','y'] then begin
             OptionBody:=True;
             ParamIn(Fil);
         end;
       end;

    3: begin
         PullColor:=Color2.Setting;
         SelectMenuSFirst(PWinX,PWinY+4,1,5,15+5,4,5);
         Action:=False;
         repeat
             SetMenuVal(0,15+5,WriteParamMenu,DGSYS.FullPath,5,0);
             SetMenuVal(1,15+5,WriteParamMenu,DGSYS.DPMOut,5,0);
             Str0:=DGSYS.SYSTEMNAME+'.PRM';
             SetMenuVal(3,15+5,WriteParamMenu,Str0,6,12);
             Sel2:=SelectMenuSNext(WriteParamMenu,'','');
             PullColor:=Color2.WindowInput;
             case Sel2 of
                 0:begin
                     toggle(DGSYS.FullPath);
                     if DGSYS.DPMOut[1]='Y' then DGSYS.FullPath:='No  ';
                   end;
                 1:begin
                     toggle(DGSYS.DPMOut);
                     if DGSYS.DPMOut[1]='Y' then DGSYS.FullPath:='No  ';
                   end;
                 2:begin
                     Fil:=DGSYS.SYSTEMDIR+DGSYS.SYSTEMNAME+'.INI';
                     if not Find(Fil,False) or (InputYN(PWinX,PWinY+3,Overwrite) in ['Y','y']) then begin
                         IniOut(Fil);
                         Action:=True;
                     end;
                   end;
                 3:begin
                     Fil:=DGSYS.SYSTEMDIR+DGSYS.SYSTEMNAME+'.PRM';
                     if not Find(Fil,False) or (InputYN(PWinX,PWinY+4,Overwrite) in ['Y','y']) then begin
                         ParamOut(Fil);
                         Action:=True;
                     end;
                   end;
                 4:begin
                     Path:=DGSYS.ParamFile;
                     if GetFileName(PWinX,PWinY+5,Fil,Path,'.PRM','PARAMETER FILE') then begin
                        if not Find(Fil,False) or (InputYN(PWinX,PWinY+5,Overwrite) in ['Y','y']) then begin
                            ParamOut(Fil);
                            Action:=True;
                        end;
                     end;
                   end;
             end;
         until (Sel2<0) or Action;
         SelectMenuSEnd;
      end;

    end;

end;

end.
