(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* ėp葱 *)

unit Display;

interface

uses Windows,Messages,Crt,PullMenu,Jctype,Variable,Gra2CRT,DosCall,SysUtils;

Type Real=Double;

var  UFileStr: array [1..maxfil] of String[14];
     UFileCol: array [1..maxfil] of Word;

procedure StopGraph;
procedure StartGraph;
{ʕ\p֐}
function  MakeFileName(fil:string):string;
function  MakeFileName2(fil:string):string;
function  RangeCheck(a,min,max:real):real;
{ʕ\}
procedure ClearScreen;
procedure ClrScr2;
procedure FileParamDisp(dc:HDC);
procedure FileParamDisp2(dc:HDC);
function  MaskedFile(Fil:Integer):Boolean;
function  MaskedFile2(Fil:Integer):Boolean;
function  ChangedFile(Fil:Integer):Boolean;
procedure Fdisp(Fil:Integer;Blight:Boolean);
procedure Fdisp2(Fil:Integer;Blight:Boolean);
procedure Fdisp3(Clear,All:Boolean);
procedure FileDisp;
procedure FileDisp2;
{EBhEo}
function  KeyCheck:boolean;
procedure Errordisp(mes:string);
function  InputYN(x,y:Integer;Mes:String):Char;
procedure Verify(x,y:Integer;Mes:String);
procedure PutMessage(x,y:Integer;Str:String;Attr:Word);
procedure Toggle(var Str:Str4);
procedure SetMenuVal(Num,Len:Integer;var Menu;var Dat;Size,StrSize:Integer);
function  WindowInputReal(x,y:Integer;title:String;var dat:real;Size:Integer):Boolean;
procedure ValInput(x,y:Integer;Title:String;var Dat;Size:Integer;Min,Max:Real);
function  SelectFile(Single:Boolean;var SelectSet:ByteSet;Title:String):Integer;

Const Graphic:Boolean=False;
      BriefMode:Boolean=False;
      GraphicWnd:Integer=0;
Const

   DotMenu : array [0..51] of String[14] = ('A:     | ',
					    'B: p `  ',
					    'C: Spline  ` ',
					    'D: Spline  Z ',
					    'E: Spline  `S',
                                            'F:B-Spline `B',
                                            'G:B-Spline ZB',
					    'H:   _      ',
					    'I:     E ',
					    'J:      ',
					    'K:@    ',
					    'L:@   E',
                                            'M:d  ',
                                            'N:d E',
					    'O: l p  ',
					    'P: l p  ',
					    'Q: l p E',
					    'R: H `  ',
					    'S: H `  ',
					    'T: H ` E',
					    'U: O p  ',
					    'V: O p  ',
					    'W: O p E',
					    'X: t O  ',
					    'Y: t O  ',
					    'Z: t O E',
					    'a:\  @ { ',
					    'b:    _ ~ ',
					    'c: c _  ',
					    'd: c _ a ',
					    'e: c _ aE',
					    'f:  _  ',
					    'g:  _  ',
					    'h:  _ E',
                                            'i:c K i u ',
                                            'j: K i v ',
					    'k: p  ^ ',
                                            'l:  `  ',
                                            'm:  `  ',
                                            'n:  ` E',
                                            'o:c덷_ }V',
				            'p:덷_ }H',
                                            'q:Fit ꎟ 1',
                                            'r:Fit  2',
                                            's:Fit O 3',
                                            't:Fit l 4',
                                            'u:Fit ܎ 5',
                                            'v:Fit Z 6',
					    'w:Fit xL P',
					    'x:Fit w E',
					    'y:Fit ΐ L',
                                            'z:Fit  U');

implementation

function MakeFileName(fil:string):string;
var Dir :DirStr;
    Name:NameStr;
    Ext :ExtStr;
begin
   if fil='' then MakeFileName:='        .   '
   else begin
       FSplit(fil,dir,name,ext);
       MakeFileName:=Copy(name+'        ',1,8)+Copy(ext+'    ',1,4);
   end;
end;

function MakeFileName2(fil:string):string;
var Dir :DirStr;
    Name:NameStr;
    Ext :ExtStr;
begin
   if fil='' then MakeFileName2:=''
   else begin
       FSplit(fil,dir,name,ext);
       MakeFileName2:=name+ext;
   end;
end;

function RangeCheck(a,min,max:real):real;
begin
  if a<min then rangecheck:=min
  else if a>max then rangecheck:=max
  else rangecheck:=a;
end;


{ʕ\}

function DgWinProc2(Wnd:HWND;iMessage:UINT;ParamW:WPARAM;ParamL:LPARAM): LRESULT; stdcall;
var rc:TRECT;
    ps:TPaintStruct;
    dc:HDC;
    brush:HBrush;
    rect:Trect;
begin
  DgWinProc2:=0;
  case iMessage of
  WM_PAINT:
    begin
      if GetUpdateRect(Wnd,rc,FALSE) then begin
        dc:=BeginPaint(Wnd,ps);
        if (MEMDC<>0) then BitBlt(dc,0,0,gSize,gSize,MEMDC,0,0,SRCCOPY);
        EndPaint(Wnd,ps);
      end;
    end;
  else begin
    DgWinProc2:=DefWindowProc(Wnd,iMessage,ParamW,ParamL);
  end;
  end;
end;

const SetWndClass2:Boolean=False;
const szDgClassName2:PChar='DGWIN2';

procedure OpenWindow2(X,Y,Width,Height:Integer);
var Win,WinCur,WinPrev:DgWinPo;
    dwStyle:DWORD;
    winx,winy,winwidth,winheight:Integer;
    orgfont:HFONT;
    tm:TTextMetric;
    rect:TRect;
    Width2,Height2:Integer;
    DgWc:TWndClass;
begin
  if (GraphicWnd<>0) then exit;
  winx:=x;
  winy:=y;
  winwidth:=gSize+GetSystemMetrics(SM_CXBORDER);
  winheight:=gSize+GetSystemMetrics(SM_CYBORDER);
  if not SetWndClass2 then begin
    DgWc.style      :=0;
    DgWc.lpfnWndProc:=@DgWinProc2;
    DgWc.cbClsExtra :=0;
    DgWc.cbWndExtra :=0;
    DgWc.hInstance  :=hInstance;
    DgWc.hIcon      :=0;
    DgWc.hCursor    :=0;
    DgWc.hbrBackground:=0;
    DgWc.lpszMenuName:=NIL;
    DgWc.lpszClassName:=szDgClassName2;
    if (RegisterClass(DgWc)=0) then exit;
    SetWndClass2:=TRUE;
  end;
  dwStyle:=WS_VISIBLE or WS_BORDER or WS_CHILD or WS_CLIPSIBLINGS;
  GraphicWnd:=CreateWindow(szDgClassName2,NIL,dwStyle,
                           winx,winy,winwidth,winheight,
                           MainWin.Wnd,0,hInstance,NIL);
  if GraphicWnd=0 then exit;
  GRADC:=GetDC(GraphicWnd);
  SetBkMode(GRADC,TRANSPARENT);
  if (MEMDC<>0) then BitBlt(GRADC,0,0,gSize,gSize,MEMDC,0,0,SRCCOPY);
  SetWindowPos(GraphicWnd,HWND_TOP,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_DRAWFRAME);
  SetForegroundWindow(GraphicWnd); 
  BringWindowToTop(GraphicWnd);
end;

procedure CloseWindow2;
begin
  if GraphicWnd<>0 then begin
    ReleaseDC(GraphicWnd,GRADC);
    GRADC:=0;
    DestroyWindow(GraphicWnd);
    GraphicWnd:=0;
  end;
end;

procedure StopGraph;
begin
  Graphic:=False;
  BriefMode:=False;
  CloseWindow2;
  InvalidateRect(MainWin.Wnd,NIL,False);
end;

procedure StartGraph;
begin
  Graphic:=True;
  OpenWindow2(gViewX1,gViewY1,gSize,gSize);
end;

procedure ClearScreen;
var i:Integer;
begin
    CloseGra2Crt;
    OpenGra2Crt;
    NGRAPH.Drawn:=false;
    for i:=1 to FilePar.Num do FilePar.Body[i].IsRead:=False;
end;


procedure ClrScr2;
begin
  InvalidateRect(MainWin.Wnd,NIL,False);
(*    ClearFrameXY(1,1,26,THeight,Color.MainMenu.Frame);
    ClearFrameXY(27,1,TWidth-26,THeight,Crt.White); *)
end;

procedure FileParamDisp(dc:HDC);
var i,Pos:Integer;
    S,S2:String;
begin
    for i:=1 to FilePar.Num do With FilePar.Body[i] do begin
        Pos:=i+3;
	if Axisx=0 then PullWriteXY2(dc,16,Pos,Chr($1F),Color2.Param[2])
                   else PullWriteXY2(dc,16,Pos,Chr($1E),Color2.Param[2]);
	if Axisy=0 then PullWriteXY2(dc,17,Pos,Chr($1D),Color2.Param[2])
                   else PullWriteXY2(dc,17,Pos,Chr($1C),Color2.Param[2]);
        Str(hax:2,S);
        Str(vax:2,S2);
        S:=S+S2+Copy(DotMenu[DotTyp],12,3);
	PullWrite2(dc,S,Color2.Param[0]);
        PullWrite2(dc,' ',DotCol+Crt.Reverse);
    end;
end;

function  MaskedFile(Fil:Integer):Boolean;
var j:Integer;
begin
     MaskedFile:=False;
     for j:=1 to Mask.Num do if Mask.Body[j].Fil=Fil then MaskedFile:=True;
end;

function  MaskedFile2(Fil:Integer):Boolean;
var j:Integer;
begin
     MaskedFile2:=False;
     for j:=1 to MaskReg.Num do if MaskReg.Body[j].Fil=Fil then MaskedFile2:=True;
end;

function  ChangedFile(Fil:Integer):Boolean;
var j:Integer;
begin
     ChangedFile:=False;
     for j:=1 to ChgData.Num do if ChgData.Body[j].Fil=Fil then ChangedFile:=True;
end;

procedure FileParamDisp2(dc:HDC);
var i,j:Integer;
    S,S2:String;
begin
    for i:=1 to FilePar.Num do With FilePar.Body[i] do begin
        Str(Smoothingx:3,S);
        Str(Smoothingy:3,S2);
        S:=S+S2;
        Str(SkipNum:4,S2);
        S:=S+S2;
        Str(ReadStep:4,S2);
        S:=S+S2;
        Str(FinalLine:4,S2);
        S:=S+S2+' ';
        PullWriteXY2(dc,26,i+3,S,Color2.Param[0]);
        if MaskedFile(i) or MaskedFile2(i) or ChangedFile(i) then
            PullWriteXY2(dc,45,i+3,' ',Color2.Param[3])
        else
            PullWriteXY2(dc,45,i+3,' ',Color2.Param[0]);
	if (DotNum>=0) then begin
            Str(DotNum:6,S);
            PullWrite2(dc,S+' ',Color2.Param[0]);
        end else PullWrite2(dc,'       ',Color2.Param[0]);
        PutStr2(dc,53,i+3,27,Comment,Color2.Param[1],Color2.Param[2]);
    end;
end;

procedure Fdisp(Fil:Integer;Blight:Boolean);
var dc:HDC;
    orgfont:HFONT;
begin
  dc:=GetDc(MainWin.Wnd);
  SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
  SetTextCharacterExtra(dc,WinEnv.TExtra);
  orgfont:=SelectObject(dc,Font);
  Fdisp2(Fil,Blight);
  PullWriteXY2(dc,2,Fil+3,UFileStr[Fil],UFileCol[Fil]);
  SelectObject(dc,orgfont);
  ReleaseDc(MainWin.Wnd,dc); 
end;

procedure Fdisp2(Fil:Integer;Blight:Boolean);
var Attr:Word;
begin
 With FilePar.Body[Fil] do begin
   if fil>FilePar.Num then begin
     UFileStr[fil]:='..............';
     UFileCol[fil]:=Color2.FileDisp.Back;
   end else begin
      if Blight then Attr:=Color2.FileDisp.First
      else if IsRead and (DotNum=-1) then Attr:=Color2.FileDisp.SelBar
      else if IsRead then Attr:=Color2.FileDisp.Bar
      else Attr:=Color2.FileDisp.Sel;
      UFileStr[fil]:=' '+MakeFileName(Name)+' ';
      UFileCol[fil]:=Attr;
   end;
 end;
end;

procedure Fdisp3(Clear,All:Boolean);
var dc:HDC;
    i:Integer;
    orgfont:HFONT;
    num:Integer;
begin
    dc:=GetDc(MainWin.Wnd);
    SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
    SetTextCharacterExtra(dc,WinEnv.TExtra);
    orgfont:=SelectObject(dc,Font);
    if All then num:=MaxFil
    else num:=FilePar.Num;
    for i:=1 to num do begin
      if Clear then Fdisp2(i,False);
      PullWriteXY2(dc,2,i+3,UFileStr[i],UFileCol[i]);
    end;
    SelectObject(dc,orgfont);
    ReleaseDc(MainWin.Wnd,dc);
end;

procedure FileDisp;
var i:integer;
begin
  Fdisp3(True,True);
  InvalidateRect(MainWin.Wnd,NIL,False);
end;

procedure FileDisp2;
var dc:HDC;
    brush:HBrush;
    rect:TRect;
    orgfont:HFONT;
begin
  BriefMode:=True;
  dc:=GetDC(MainWin.Wnd);
  brush:=CreateSolidBrush(RGB(0,0,0));
  rect.left:=0;
  rect.top:=0;
  rect.right:=FWidth*TWidth+1;
  rect.bottom:=FHeight*THeight+1;
  FillRect(dc,rect,brush);
  DeleteObject(brush);
  SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
  SetTextCharacterExtra(dc,WinEnv.TExtra);
  orgfont:=SelectObject(dc,MainWin.Font);
  MakeFrameXY2(dc,1,3,24,FilePar.Num,Color2.FileDisp.Frame,Color2.FileDisp.Title,Color2.FileDisp.Title2,Color2.FileDisp.Shadow,
               '---DATA FILE-----X-Y-D-C','');
  ClearFrameXY2(dc,2,4,24,FilePar.Num,Color2.FileDisp.Back);
  Fdisp3(False,False);
  FileParamDisp(dc);
  SelectObject(dc,orgfont);
  ReleaseDC(MainWin.Wnd,dc);
end;


{EBhECvbg}

procedure Errordisp(mes:string);
var Ch:char;
    x:Integer;
    len:Integer;
begin
   Beep;
   if WinErrorDisp then begin
     len:=Length(mes);
     if len>=SizeOf(String)-1 then len:=SizeOf(String)-2;
     mes[len+1]:=Chr(0);
     MessageBox(0,PChar(@mes[1]),'VERIFY',MB_OK);
   end else begin
     PullColor:=Color2.Error;
     Ch:=WIndowInputChar(1,THeight,Copy(mes,1,75),'VERIFY','',[Chr(1)..Chr($FF)]);
   end;
end;

function InputYN(x,y:Integer;Mes:String):Char;
begin
    PullColor:=Color2.Verify;
    InputYN:=WindowInputChar(x,y,Mes,'VERIFY','',['Y','y','N','n',PullKey.ESC]);
end;

procedure Verify(x,y:Integer;Mes:String);
var Ch:Char;
begin
    PullColor:=Color2.Verify2;
    Ch:=WindowInputChar(x,y,Mes,'VERIFY','',[Chr(1)..Char($FF)]);
end;

var MessageMenu:String;

procedure PutMessage(x,y:Integer;Str:String;Attr:Word);
begin
    PullColor.Frame:=Color2.Message2[0];
    PullColor.Back:=Attr;
    PullColor.Sel:=Attr;
    PullColor.Shadow:=Color2.Message2[1];
    OpenWindow(x,y,Length(Str)+2,1);
    MakeFrame('','');
    MessageMenu:=Str;
    SetMenuString(1,1,Length(Str),2,1,MessageMenu);
    PullWriteXYW(2,2,' '+Str+' ',Attr);
end;

function KeyCheck:boolean;
var Key:Word;
begin
     KeyCheck:=False;
     Key:=0;
     CheckEscape(Key);
     if Key=VK_ESCAPE then KeyCheck:=True;
end;

procedure Toggle(var Str:Str4);
begin
   if Str[1]='Y' then Str:='No  '
		 else Str:='Yes ';
end;

procedure SetMenuVal(Num,Len:Integer;var Menu;var Dat;Size,StrSize:Integer);
var ValStr:String;
    MStr:String;
type ByteArray = array [0..MAXINT div 4] of Byte;
begin
   FillChar(MStr,Sizeof(MStr),' ');
   case Size of
      1: Str(Integer(Dat):5,ValStr);
      2: Str(LongInt(Dat):10,ValStr);
      3: Str(Real(Dat):5:1,ValStr);
      4: Str(Real(Dat):15,ValStr);
      5: ValStr:=Str4(Dat);
      6: ValStr:=Copy(String(Dat),1,StrSize);
   end;
   Move(ByteArray(Menu)[Num*(Len+1)],MStr,Len+1);
   case Size of
      1: MStr[0]:=Chr(Len-5);
      2: MStr[0]:=Chr(Len-10);
      3: MStr[0]:=Chr(Len-5);
      4: MStr[0]:=Chr(Len-15);
      5: Mstr[0]:=Chr(Len-4);
      6: Mstr[0]:=Chr(Len-StrSize);
   end;
   SetMenu(Num,Len,Menu,MStr+ValStr);
end;

function WindowInputReal(x,y:Integer;title:String;var dat:real;Size:Integer):Boolean;
var S:String;
    code:Integer;
    a:real;
    Input:Boolean;
begin
   if Size=1      then Str(dat:6:0,S)
   else if Size=2 then Str(dat:10:0,S)
   else if Size=3 then Str(dat:5:1,S)
   else if Size=4 then Str(dat:15,S);
   PullColor:=Color2.WindowInput;
   Input:=WindowInput(x,y,25,S,title,'');
   if Input then begin
       val(S,a,code);
       if code=0 then dat:=a
	         else Input:=False;
   end;
   WindowInputReal:=Input;
end;

procedure ValInput(x,y:Integer;Title:String;var Dat;Size:Integer;Min,Max:Real);
var D:Real;
    code:Integer;
    S:String;
    Input:Boolean;
begin
    if Size=1 then begin
	 D:=Integer(Dat);
	 Input:=WindowInputReal(x,y,Title,D,Size);
	 Integer(Dat):=Round(rangecheck(D,min,max));
    end else if Size=2 then begin
	 D:=LongInt(Dat);
	 Input:=WindowInputReal(x,y,Title,D,Size);
	 LongInt(Dat):=Round(rangecheck(D,min,max));
    end else if Size=3 then begin
	 D:=Real(Dat);
	 Input:=WindowInputReal(x,y,Title,D,Size);
	 Real(Dat):=rangecheck(D,min,max);
    end else if Size=4 then begin
	 D:=Real(Dat);
	 Input:=WindowInputReal(x,y,Title,D,Size);
	 Real(Dat):=rangecheck(D,min,max);
    end else if Size=5 then begin
	 S:=Str4(Dat);
	 PullColor:=Color2.WindowInput;
	 if WindowInput(x,y,25,S,title,'') then begin
             val(S,D,code);
             if code=0 then begin
                 D:=rangecheck(D,min,max);
                 Str(Trunc(D),S);
                 Str4(Dat):=Copy('    ',1,4-Length(S))+S;
             end else Str4(Dat):='Auto';
         end;
    end;
end;

function SelectFile(Single:Boolean;var SelectSet:ByteSet;Title:String):Integer;
var i:Integer;
   Ch:char;
   SelFile:array [1..maxfil+1] of String[12];
begin
  for i:=1 to FilePar.Num do SetMenu(i-1,12,SelFile,MakeFileName(FilePar.Body[i].Name));
  if not Single then SetMenu(FilePar.Num,12,SelFile,' ALL FILES');
  if FilePar.Num<1 then begin
      SelectFile:=0;
      SelectSet:=[];
      exit;
  end else if (FilePar.Num=1) then begin
     SelectFile:=1;
     SelectSet:=[1];
     exit;
  end;
  PullColor:=Color2.SelFile;
  if not Single then i:=SelectMenuS(1,3,1,FilePar.Num+1,12,FilePar.Num,FilePar.Num+1,SelFile,Title,'ISHIFT+CR',FilePar.Num)
  else i:=SelectAMenu(1,3,1,FilePar.Num,12,0,FilePar.Num,SelFile,Title,'   I CR  ');
  if i<0 then begin
       SelectFile:=0;
       SelectSet:=[];
       Exit;
  end else if not Single then begin
       if i=FilePar.Num then begin
            SelectSet:=[1..FilePar.Num];
            SelectFile:=1;
	    Exit;
       end else begin
	    i:=0;
	    while not Menued(i,12,SelFile) do Inc(i);
	    SelectFile:=i+1;
            SelectSet:=[];
            for i:=1 to FilePar.Num do if Menued(i-1,12,SelFile) then SelectSet:=SelectSet+[i];
       end;
  end else begin
      SelectFile:=i+1;
      SelectSet:=[i+1];
  end;
end;


end.
