(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* fth葱 *)

unit GUI;

interface

uses Crt,DOSCALL,Gra2Crt,GraGraph,Clip,PullMenu,Data,Variable,DataScal,Windows;

Type Real=Double;

function  InputPos(Mes:String;Preview,ShiftF,HomeF:Boolean;var x,y:integer;xf,yf,Mode,minx,miny,maxx,maxy:Integer):Integer;
procedure SetLineXor(x1,y1,x2,y2:Integer);
procedure SetGauge;
procedure SetGauge2;

implementation

var PosMenu:array[0..9] of String[17];

function InputPos(Mes:String;Preview,ShiftF,HomeF:Boolean;var x,y:integer;xf,yf,Mode,minx,miny,maxx,maxy:Integer):Integer;
var
    WinY,i,xm,ym,x0,y0,dd,ddk,dx,dy:integer;
    x1,y1:Real;
    msx,msy,msx0,msy0:Integer;
    gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
    xs,xe,ys,ye:Integer;
    Shift,Ctrl,Grph:Boolean;
    Start,Po:Integer;
    Key:Word;
    PullWindow:WindowXY;
    PullMode:SelectModeType;
    Size:Integer;
    S,S1:String;
begin
  for i:=0 to 9 do PosMenu[i]:='';
  PullColor:=Color2.Verify2;
  if not Preview then begin
    OpenWindow(1,THeight,17+2,10);
    MakeFrame('OPERATION','');
    ClearFrame;
    SetMenuString(1,10,17,11,10,PosMenu);
  end else begin
    OpenWindow(1,THeight,17+2,5);
    MakeFrame('OPERATION','');
    ClearFrame;
    SetMenuString(1,5,17,11,5,PosMenu);
  end;
  if not Preview then WinY:=7
  else WinY:=2;
  PullWriteXYW(3,WinY,               '       ESC: Abort  ',Color2.Verify2.Back);
  PosMenu[WinY-2]:='       ESC: Abort  ';
  Inc(WinY);
  PullWriteXYW(3,WinY,               ' SHIFT/TAB: Fine   ',Color2.Verify2.Back);
  PosMenu[WinY-2]:=' SHIFT/TAB: Fine   ';
  Inc(WinY);
  if ShiftF then begin
    PullWriteXYW(3,WinY,'SHIFT + CR: End    ',Color2.Verify2.Back);
    PosMenu[WinY-2]:='SHIFT + CR: End    ';
  end else begin
    PullWriteXYW(3,WinY,'        CR: End    ',Color2.Verify2.Back);
    PosMenu[WinY-2]:='        CR: End    ';
  end;
  Inc(WinY);
  if HomeF then begin
    PullWriteXYW(3,WinY, '   BS/HOME: Go back',Color2.Verify2.Back);
    PosMenu[WinY-2]:='   BS/HOME: Go back';
  end;
  Inc(WinY);
  PullWriteXYW(1,WinY,Copy(Mes,1,20),Color2.Verify2.Back);
  PosMenu[WinY-2]:=Copy(Mes,1,20);
//  PullWriteXYW(1,1,'',Color2.Verify2.Back);
//With PullKey do begin
  nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
  DGSYS.Device:=0;
  nSetWriteMode(1);
  nSetWindowFull;
  nResetViewPort;
  nSetLineStyle(1,1,Color2.Graphic[4],0);
  xm:=x;
  ym:=y;
  Key:=$0100;
  repeat
    if Key<>0 then begin
        if Mode=1 then begin
            if xf>0 then begin
              if xm+xf>maxx then xm:=maxx-xf;
              if xm<minx then xm:=minx;
            end else begin
              if xm>maxx then xm:=maxx;
              if xm+xf<minx then xm:=minx-xf;
            end;
            if yf>0 then begin
              if ym+yf>maxy then ym:=maxy-yf;
              if ym<miny then ym:=miny;
            end else begin
              if ym>maxy then ym:=maxy;
              if ym+yf<miny then ym:=miny-yf;
            end;
        end else if Mode=4 then begin
            if ym<0 then ym:=0;
            if xm<0 then xm:=0;
            if yf+ym>maxy then ym:=maxy-yf;
            if xf+xm>maxx then xm:=maxx-xf;
        end else if Mode=5 then begin
            if (ym<0) or (xm<0) then begin
                ym:=0;
                xm:=0;
            end;
            if (ym+yf)>maxy then begin
                ym:=maxy-yf;
                xm:=maxy-yf;
            end;
            if (xm+xf)>maxx then begin
                ym:=maxx-xf;
                xm:=maxx-xf;
            end;
        end else begin
            if ym>maxy then ym:=maxy;
            if xm>maxx then xm:=maxx;
            if ym<miny then ym:=miny;
            if xm<minx then xm:=minx;
        end;
        if Mode=0 then begin
             nRectAngle2(xm,ym,xf,yf,False);
             nPutImage(xm,ym,Color2.Graphic[3]);
        end else if Mode=1 then begin
             nRectAngle2(xm,ym,xm+xf,ym+yf,False);
        end else if Mode=2 then begin
{             nPutImage(xm+2,ym+2,Color.Graphic[3]);}
        end else if Mode=3 then begin
             nLine2(xm,ym,xf,yf);
             nPutImage(xm,ym,Color2.Graphic[3]);
        end else if Mode in [4,5] then begin
             nRectAngle2(xf,yf,xf+xm,yf+ym,False);
             nPutImage(xf+xm,yf+ym,Color2.Graphic[3]);
        end;
        if Mode in [0,3] then begin
             nLine2(xm,miny,xm,miny+400);
             nLine2(maxx,ym,maxx-400,ym);
             nLine2(xf,miny,xf,miny+400);
             nLine2(maxx,yf,maxx-400,yf);
        end else if Mode=1 then begin
             nLine2(xm,miny,xm,miny+400);
             nLine2(maxx,ym,maxx-400,ym);
             nLine2(xm+xf,miny,xm+xf,miny+400);
             nLine2(maxx,ym+yf,maxx-400,ym+yf);
        end else if Mode=2 then begin
             nLine2(xm,miny,xm,maxy);
             nLine2(minx,ym,maxx,ym);
        end else if Mode in [4,5] then begin
             nLine2(xf,miny,xf,miny+400);
             nLine2(maxx,yf,maxx-400,yf);
             nLine2(xf+xm,miny,xf+xm,miny+400);
             nLine2(maxx,yf+ym,maxx-400,yf+ym);
        end;
    end;
    x0:=xm;
    y0:=ym;

   if not Preview then begin
    WinY:=2;
    Str(x0/100:3:2,S1);
    S1:='      '+S1;
    S1:=Copy(S1,Length(S1)-5,6);
    S:=S1+'mm';
    Str(y0/100:3:2,S1);
    S1:='      '+S1;
    S1:=Copy(S1,Length(S1)-5,6);
    S:=S+' '+S1+'mm';
    PullWriteXYW(3,WinY,S,Color2.Verify2.Back);
    PosMenu[WinY-2]:=S;

    for i:=0 to 1 do begin
      S1:='---------------';
      if AxisPar[i*2].SetMin and AxisPar[i*2].SetMax then begin
        nSetWindow(AxisPar[i*2].Min,AxisPar[i*2].Min,AxisPar[i*2].Max,AxisPar[i*2].Max);
        x1:=GToX(x0-gx1);
        if ConvData(False,AxisPar[i*2].ScType,x1) then Str(x1:15,S1);
      end;
      if (i=0) then S1:='X:'+S1
      else S1:='U:'+S1;
      WinY:=i*2+3;
      PullWriteXYW(3,WinY,S1,Color2.Verify2.Back);
      PosMenu[WinY-2]:=S1;
      S1:='---------------';
      if AxisPar[i*2+1].SetMin and AxisPar[i*2+1].SetMax then begin
        nSetWindow(AxisPar[i*2+1].Min,AxisPar[i*2+1].Min,AxisPar[i*2+1].Max,AxisPar[i*2+1].Max);
        y1:=GToY(y0-gy1);
        if ConvData(False,AxisPar[i*2+1].ScType,y1) then Str(y1:15,S1);
      end;
      if (i=0) then S1:='Y:'+S1
      else S1:='R:'+S1;
      WinY:=i*2+4;
      PullWriteXYW(3,WinY,S1,Color2.Verify2.Back);
      PosMenu[WinY-2]:=S1;
    end;
//    PullWriteXYW(1,1,'',Color2.Verify2.Back);
  end;

    nSetWindowFull;
    Key:=0;
    Shift:=False;
    msx:=Dot2pixel(xm);
    msy:=Dot2pixel(ym);
    msx0:=msx;
    msy0:=msy;
    dx:=Pixel2dot(msx-msx0);
    dy:=Pixel2dot(msy-msy0);
    PullReadKey(Key,Shift,Ctrl,Grph);
//    ChgPullKey(Key,Ch,Ch2);
    if Grph then ddk:=1
    else if Shift then ddk:=50
    else ddk:=500;
    if Key=VK_UP then dy:=-ddk
    else if Key=VK_LEFT then dx:=-ddk
    else if Key=VK_DOWN then dy:=ddk
    else if Key=VK_RIGHT then dx:=ddk;
    if Abs(dx)>Abs(dy) then dd:=dx
                       else dd:=dy;
    if Mode=5 then begin
        Inc(xm,dd);
        Inc(ym,dd);
    end else begin
        Inc(xm,dx);
        Inc(ym,dy);
    end;
    if Key<>0 then begin
        if Mode=0 then begin
             nRectAngle2(x0,y0,xf,yf,False);
             nPutImage(x0,y0,Color2.Graphic[3]);
        end else if Mode=1 then begin
             nRectAngle2(x0,y0,x0+xf,y0+yf,False);
        end else if Mode=2 then begin
{             nPutImage(x0+2,y0+2,Color.Graphic[3]);}
        end else if Mode=3 then begin
             nLine2(x0,y0,xf,yf);
             nPutImage(x0,y0,Color2.Graphic[3]);
        end else if Mode in [4,5] then begin
             nRectAngle2(xf,yf,xf+x0,yf+y0,False);
             nPutImage(xf+x0,yf+y0,Color2.Graphic[3]);
        end;
        if Mode in [0,3] then begin
             nLine2(x0,miny,x0,miny+400);
             nLine2(maxx,y0,maxx-400,y0);
             nLine2(xf,miny,xf,miny+400);
             nLine2(maxx,yf,maxx-400,yf);
        end else if Mode=1 then begin
             nLine2(x0,miny,x0,miny+400);
             nLine2(maxx,y0,maxx-400,y0);
             nLine2(x0+xf,miny,x0+xf,miny+400);
             nLine2(maxx,y0+yf,maxx-400,y0+yf);
        end else if Mode=2 then begin
             nLine2(x0,miny,x0,maxy);
             nLine2(minx,y0,maxx,y0);
        end else if Mode in [4,5] then begin
             nLine2(xf,miny,xf,miny+400);
             nLine2(maxx,yf,maxx-400,yf);
             nLine2(xf+x0,miny,xf+x0,miny+400);
             nLine2(maxx,yf+y0,maxx-400,yf+y0);
        end;
    end;
  until Key in [VK_RETURN,VK_ESCAPE,VK_HOME,VK_BACK];
  if Key=VK_ESCAPE then InputPos:=-1
  else if Key=VK_HOME then InputPos:=-2
  else begin
      if Key=VK_BACK then InputPos:=-2
      else if Shift then InputPos:=2
      else InputPos:=1;
      x:=xm;
      y:=ym;
  end;
  nSetWriteMode(0);
//end;
  PullMenu.CloseWindow;
end;

procedure SetLineXor(x1,y1,x2,y2:Integer);
begin
  DGSYS.Device:=0;
  nResetViewPort;
  nSetWindowFull;
  nSetWriteMode(1);
  nSetLineStyle(1,1,Color2.Graphic[5],0);
  nLine2(x1,y1,x2,y2);
  nSetWriteMode(0);
end;

procedure SetGauge;
var i,Len,x:Integer;
begin
  DGSYS.Device:=0;
  nSetWriteMode(1);
  nResetViewPort;
  nSetWindowFull;
  for i:=0 to 83 do begin
      if i Mod 40=0 then begin
          Len:=300;
          nSetLineStyle(0,1,Color2.Graphic[2],0);
      end else begin
          nSetLineStyle(0,1,Color2.Graphic[1],0);
          if i Mod 4=0 then Len:=200
          else if i Mod 2=0 then Len:=100
          else Len:=0;
      end;
      x:=i*250;
      nLine2(x,0,x,Len);
      nLine2(PaperSize-Len,x,PaperSize,x);
  end;
  nSetWriteMode(0);
end;

procedure SetGauge2;
var i,x,Len:Integer;
    x1,Size:Integer;
begin
  DGSYS.Device:=0;
  nResetViewPort;
  nSetWindowFull;
  nSetFillColor(0);
  nRectAngle2(0,0,PaperSize,PaperSize,True);
  nSetFillColor(Color2.Graphic[0]);
  Size:=Round(PaperSize/297*210);
  x1:=Round((PaperSize-Size)*0.5);
  nRectAngle2(x1,0,x1+Size,PaperSize,True);
  nSetWriteMode(1);
  for i:=0 to 119 do begin
      if i Mod 40=0 then begin
          Len:=Round(300/297*210);
          nSetLineStyle(0,1,Color2.Graphic[2],0);
      end else begin
          nSetLineStyle(0,1,Color2.Graphic[1],0);
          if i Mod 4=0 then Len:=Round(200/297*210)
          else if i Mod 2=0 then Len:=Round(100/297*210)
          else Len:=0;
      end;
      x:=Round(i*250/297*210);
      if i<=84 then nLine2(x1+x,0,x1+x,Len);
      nLine2(x1+Size-Len,x,x1+Size,x);
  end;
  nSetWriteMode(0);
end;

end.
