(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* AP|V *)

unit Memory;

interface

uses Pullmenu,Variable,Display;

Type Real=Double;

procedure MemAlloc;

implementation

procedure MemAlloc;
var Error:Boolean;
begin
   With DGSYS do begin
     Error:=False;
     GetMem(AxisPar2,Sizeof(AxisParType));
     if AxisPar2=NIL then Error:=True;
     GetMem(MMemory,Sizeof(MemoryArrayType));
     if MMemory=NIL then Error:=True;
     GetMem(IntegData,Sizeof(MemoryArrayType));
     if IntegData=NIL then Error:=True;
     GetMem(DefData,Sizeof(MemoryArrayType));
     if DefData=NIL then Error:=True;
     GetMem(DefFirst,Sizeof(DefArrayType));
     if DefFirst=NIL then Error:=True;
     GetMem(MathData,Sizeof(MathDataType));
     if MathData=NIL then Error:=True;
     GetMem(MathCodex,Sizeof(MathCodeType));
     if MathCodex=NIL then Error:=True;
     GetMem(MathCodey,Sizeof(MathCodeType));
     if MathCodey=NIL then Error:=True;
     GetMem(LSQMathCode[0],Sizeof(MathCodeType));
     if LSQMathCode[0]=NIL then Error:=True;
     GetMem(LSQMathCode[1],Sizeof(MathCodeType));
     if LSQMathCode[1]=NIL then Error:=True;
     GetMem(LSQMathCode[2],Sizeof(MathCodeType));
     if LSQMathCode[2]=NIL then Error:=True;
     GetMem(LSQMathCode[3],Sizeof(MathCodeType));
     if LSQMathCode[3]=NIL then Error:=True;
     GetMem(LSQMathCode[4],Sizeof(MathCodeType));
     if LSQMathCode[4]=NIL then Error:=True;
     GetMem(LSQMathCode[5],Sizeof(MathCodeType));
     if LSQMathCode[5]=NIL then Error:=True;
     GetMem(LSQMathCode[6],Sizeof(MathCodeType));
     if LSQMathCode[6]=NIL then Error:=True;
     GetMem(LSQMathCode[7],Sizeof(MathCodeType));
     if LSQMathCode[7]=NIL then Error:=True;
     GetMem(UserFnCode[0],Sizeof(MathCodeType));
     if UserFnCode[0]=NIL then Error:=True;
     GetMem(UserFnCode[1],Sizeof(MathCodeType));
     if UserFnCode[1]=NIL then Error:=True;
     GetMem(FileLine,Sizeof(FileLineType));
     if FileLine=NIL then Error:=True;
     GetMem(gx,Sizeof(GraphDataType));
     if gx=NIL then Error:=True;
     GetMem(gy,Sizeof(GraphDataType));
     if gy=NIL then Error:=True;
     GetMem(gx2,Sizeof(GraphDataType));
     if gx2=NIL then Error:=True;
     GetMem(gy2,Sizeof(GraphDataType));
     if gy2=NIL then Error:=True;
     GetMem(LPos,Sizeof(LPosType));
     if LPos=NIL then Error:=True;
     GetMem(gStat,Sizeof(GStatType));
     if gStat=NIL then Error:=True;
     MaximData:=DataBuffer;
     SPMaximData:=DataBuffer;
     GetMem(spx,Sizeof(SplineDataType));
     if spx=NIL then Error:=True;
     GetMem(spy,Sizeof(SplineDataType));
     if spy=NIL then Error:=True;
     GetMem(spz,Sizeof(SplineDataType));
     if spz=NIL then Error:=True;
     GetMem(c1,Sizeof(SplineDataType));
     if c1=NIL then Error:=True;
     GetMem(c2,Sizeof(SplineDataType));
     if c2=NIL then Error:=True;
     GetMem(c3,Sizeof(SplineDataType));
     if c3=NIL then Error:=True;
     GetMem(c4,Sizeof(SplineDataType));
     if c4=NIL then Error:=True;
     GetMem(c5,Sizeof(SplineDataType));
     if c5=NIL then Error:=True;
     GetMem(c6,Sizeof(SplineDataType));
     if c6=NIL then Error:=True;
     if Error then begin
       ErrorDisp('Error: ܂DIĂD');
       MaximData:=0;
       SPMaximData:=0;
       DataBufSize:=0;
       Exit;
     end;
   end;
end;

end.
